import type { TypeScriptPluginConfig } from '@graphql-codegen/typescript';
import type { TypeScriptDocumentsPluginConfig } from '@graphql-codegen/typescript-operations';
export interface SvelteApolloPluginConfig extends TypeScriptPluginConfig, TypeScriptDocumentsPluginConfig {
    /**
     * Path to the apollo client for this project
     * (should point to a file with an apollo-client as `default` export)
     */
    clientPath: string;
    /** Type of client. Support `apollo` and `urql` */
    clientType: 'apollo' | 'urql';
    /** @default false */
    asyncQuery?: boolean;
    /** @default 'Doc' */
    documentVariableSuffix?: string;
}
export declare function getDefaultOptions(config?: SvelteApolloPluginConfig): SvelteApolloPluginConfig;
